/*
 * File:   LAST.c
 * Author: sysadmin
 *
 * Created on 10 January, 2013, 5:48 PM
 */

#include<p18f97j60.h>
#include<usart.h>
#include<delays.h>
#pragma config XINST=OFF
#pragma config WDT=OFF, FOSC2=ON, FOSC=HSPLL, ETHLED=OFF, STVR = ON
#pragma interrupt high_isr
#pragma config WDTPS=128

//global variables

unsigned int i;
unsigned int j;
volatile unsigned char ucaBuffer[10];
volatile unsigned int m;
unsigned int counter = 0;
volatile unsigned char ucCharBuff[10];
unsigned char ucgreenBuffer[10];
unsigned char ucredBuffer[10];

// function prototype

void function();

// interrupt function

void high_isr(void);
#pragma code high_vector=0x08

//interrupt vector

void interrupt_at_high_vector(void)
{
    _asm
    goto high_isr
            _endasm
}
#pragma code

//interrupt routine

#pragma interrupt high_isr

void high_isr()
{
    if (PIR1bits.RC1IF == 1)
    {
        PORTJ = 0X01;
        INTCONbits.PEIE = 0;
        for (i = 0; i < 10; i++)
        {
            ucaBuffer[i] = RCREG1;
            m = 1;
        }
        PIR1bits.RC1IF = 0;
        PORTJ = 0X00;
        m = 1;
    }
}

void main()
{
    OSCTUNE = 0X40;
    TRISJ = 0;
    PORTJ = 0X00;
    TRISG = 0;
    PORTG = 0X40;
    TRISC = 0X04;
    RCONbits.IPEN = 0; //disabling interrupt priority, by default high priority
    PIE1bits.RCIE = 1;
    INTCON = 0XC0;
    Open1USART(
            USART_TX_INT_ON & //Enabling USART
            USART_RX_INT_ON &
            USART_ASYNCH_MODE &
            USART_EIGHT_BIT &
            USART_CONT_RX &
            USART_BRGH_LOW,
            67);
    ucCharBuff[0] = 0x34; // rfid tag code is stored in ucCharBuff
    ucCharBuff[1] = 0x32;
    ucCharBuff[2] = 0x30;
    ucCharBuff[3] = 0x30;
    ucCharBuff[4] = 0x41;
    ucCharBuff[5] = 0x34;
    ucCharBuff[6] = 0x36;
    ucCharBuff[7] = 0x41;
    ucCharBuff[8] = 0x31;
    ucCharBuff[9] = 0x39;
    ucgreenBuffer[0] = 0x02;
    ucgreenBuffer[1] = 0x90;
    ucgreenBuffer[2] = 0x00;
    ucgreenBuffer[3] = 0x25;
    ucgreenBuffer[4] = 0x04;
    ucgreenBuffer[5] = 0x00;
    ucgreenBuffer[6] = 0x02;
    ucgreenBuffer[7] = 0x01;
    ucgreenBuffer[8] = 0x04;
    ucgreenBuffer[9] = 0xB6;
    //    ucredBuffer[0] = 0x02;
    //    ucredBuffer[1] = 0xD0;
    //    ucredBuffer[2] = 0x00;
    //    ucredBuffer[3] = 0x25;
    //    ucredBuffer[4] = 0x04;
    //    ucredBuffer[5] = 0x00;
    //    ucredBuffer[6] = 0x01;
    //    ucredBuffer[7] = 0x01;
    //    ucredBuffer[8] = 0x04;
    //    ucredBuffer[9] = 0xF5;


    while (1)
    {
        WDTCONbits.SWDTEN = 1;
        if (m == 1)
        {
            WDTCONbits.SWDTEN = 0;
            for (j = 0; j < 10; j++)
            {
                //check = (ucaBuffer[j] == ucCharBuff[j]) ? 1 : 0; // when this loop is over if same card "check = 1" , if diff card "check = 0"
                if (!(ucCharBuff[j] == ucaBuffer[j]))
                    counter=1;
            }
            if(counter=1)
                function();
            //                if(!(counter==10)
            //                {
            //                    for(i=0;i<10;i++)
            //                    {
            //                        while(!(TXSTA1bits.TRMT));
            //                        TXREG1=ucredBuffer[i];
            //                        while(!(TXSTA1bits.TRMT));
            //                    }
            //                }

            m = 0;
        }
    }
    Close1USART();
}

void function()
{
    PORTG = 0X00;
    for (j = 0; j < 200; j++)
    {
        Delay10KTCYx(10000);
    }
    PORTG = 0X40;
    // counter=0;
    for (i = 0; i < 10; i++)
    {
        while (!(TXSTA1bits.TRMT));
        TXREG1 = ucgreenBuffer[i];
        while (!(TXSTA1bits.TRMT));
    }
}